#pragma once
#include <vector>
#include "LSMacros.h"

template <class T>

class LSVector
{
public:
  LSVector(size_t zSize = 1)
  {
    m_pData = new T[zSize];
    m_zCapacity = zSize;
  }

  ~LSVector()
  {

  }

  T& PushBack(T obj)
  {
  }

  T& PopBack()
  {
  }

  T& Insert(const size_t zPos)
  {

  }

  T& Remove(const size_t zPos)
  {

  }

  T& At(const size_t zPos)
  {
    return m_pData[zPos];
  }

  void Reserve(const size_t zSize)
  {
    T* pOld = m_pData;
    m_pData = new T[zSize];

    memmove_s(m_pData, zSize, pOld, m_zSize);
    m_zSize = zSize;
    m_zCapacity = zSize;

    DELETE_ARRAY(pOld);
  }

  void Clear() 
  {
    DELETE_ARRAY(m_pData)
  }

  size_t Size() const
  {
    return m_zSize;
  }

  size_t Capacity() const
  {
    return m_zCapacity;
  }

  T* Data() const
  {
    return m_pData;
  }

  LSVector& operator=(const LSVector oRhs)
  {

  }

  LSVector& operator[](const size_t _Pos)
  {

  }

private:

  std::vector<int> s;
  T* m_pData = nullptr;
  size_t m_zSize = 0;
  size_t m_zCapacity = 0;
};